"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createFileWatch = void 0;
const path = __importStar(require("path"));
const chokidar = __importStar(require("chokidar"));
const rxjs_1 = require("rxjs");
const path_1 = require("../utils/path");
const log = __importStar(require("../utils/log"));
function createFileWatch(projectPath, ignoredPaths = []) {
    log.debug(`Watching for changes: projectPath: ${projectPath}, ignoredPaths: ${ignoredPaths}`);
    const watch = chokidar.watch(projectPath, {
        ignoreInitial: true,
        ignored: [...ignoredPaths, /((^[\/\\])\..)|(\.mjs$)|(\.map$)|(\.metadata\.json|node_modules)/],
        persistent: true,
    });
    const handleFileChange = (event, filePath, observer) => {
        log.debug(`Watch: Path changed. Event: ${event}, Path: ${filePath}`);
        if (event === 'unlinkDir' || event === 'addDir') {
            // we don't need to trigger on directory removed or renamed as chokidar will fire the changes for each file
            return;
        }
        observer.next({
            filePath: (0, path_1.ensureUnixPath)(path.resolve(filePath)),
            event,
        });
    };
    return rxjs_1.Observable.create((observer) => {
        watch.on('all', (event, filePath) => handleFileChange(event, filePath, observer));
        return () => watch.close();
    });
}
exports.createFileWatch = createFileWatch;
//# sourceMappingURL=file-watcher.js.map